#include <iostream>
#include <vector>

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);

	vector<vector<int> > a(1000001, vector<int>(102, 0));
	vector<long long> b(1000001, 0);

	for (int i = 1; i <= 1000000; i++) {
		int j = 1;
		for (; j*j < i && j <= 100; j++) {
			if (i % j != 0) continue;
			a[i][j] = 1;
		}

		for (; j*j<i; j++) {
			if (i % j == 0) a[i][101]++;
		}

		for (int k = j < 100 ? j : 100; k > 0; k--) {
			a[i][k] += a[i][k+1];
		}
	}

	for (int i = 1; i <= 1000000; i++) {
		for (int j = 1; j*j*j < i; j++) {
			if (i % j != 0) continue;
			b[i] += a[i / j][j+1];
		}
	}

	for (int i = 2; i <= 1000000; i++) {
		b[i] = b[i] + b[i-1];
	}

	int n, x;
	cin >> n;

	for (int i = 0; i < n; i++) {
		cin >> x;
		cout << b[x] << endl;
	}

	return 0;
}
